package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.world.level.block.entity.EnchantmentTableBlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.ItemStackHandler;

public class ApothEnchantTile extends EnchantmentTableBlockEntity {
  protected ItemStackHandler inv = (ItemStackHandler)new Object(this, 1);
  
  LazyOptional<IItemHandler> invCap;
  
  public ApothEnchantTile(BlockPos pos, BlockState state) {
    super(pos, state);
    this.invCap = LazyOptional.of(() -> this.inv);
  }
  
  public void m_183515_(CompoundTag tag) {
    super.m_183515_(tag);
    tag.m_128365_("inventory", (Tag)this.inv.serializeNBT());
  }
  
  public void m_142466_(CompoundTag tag) {
    super.m_142466_(tag);
    this.inv.deserializeNBT(tag.m_128469_("inventory"));
  }
  
  public <T> LazyOptional<T> getCapability(Capability<T> cap, Direction side) {
    if (cap == ForgeCapabilities.ITEM_HANDLER)
      return this.invCap.cast(); 
    return super.getCapability(cap, side);
  }
  
  public void invalidateCaps() {
    super.invalidateCaps();
    this.invCap.invalidate();
  }
  
  public void reviveCaps() {
    super.reviveCaps();
    this.invCap = LazyOptional.of(() -> this.inv);
  }
}
